
 ////////////
 //
FUNCTION ApiGetToolBar_(cWhich)
 //      Get the position and size of the tool bar, where:
 //            do windows, onde:
 //      [<cWhich>]  -> how to return the position and size of the tool bar:
 //                     NIL     -> {nX,nY, nWidth, nHeight} position and size
 //                     'P | p' -> {nX,nY) position
 //                     'S | s' -> {nWidth, nHeight} size
 /////
STATIC  cCall
LOCAL cBuffer := Space(16),;
      nX,nY,  nX0, nY0, nX1, nY1, aDeskSize, nDeskWidth, nDeskHeight,;
      nWidth, nHeight, nDll

if cCall == NIL
   nDll  := ApiLoadDll_('User32.dll')
   cCall := DllPrepareCall(nDll, DLL_STDCALL, 'SystemParametersInfoA')
endif
DllExecuteCall(cCall, SPI_GETWORKAREA, 0, @cBuffer, SPIF_SENDCHANGE)

nX0 := Bin2u(Substr(cBuffer,  1, 4))
nY0 := Bin2u(Substr(cBuffer,  5, 4))
nX1 := Bin2u(Substr(cBuffer,  9, 4))
nY1 := Bin2u(Substr(cBuffer, 13, 4))

aDeskSize   := AppDeskTop():currentSize()
nDeskWidth  := aDeskSize[01]
nDeskHeight := aDeskSize[02]
nWidth      := (nX1 - nX0)                // Size ogf the work area
nHeight     := (nY1 - nY0)

if     nWidth     == nDeskWidth           // Is the bar in the bottom or in the top?
       if nY1     == 0                    // It is in the top
          nX      := 0
          nY      := (nY0 + 1)
          nHeight := (nDeskHeight - nY0)
       else                               // It is in the bottom
          nX      := 0
          nY      := 0
          nHeight := (nDeskHeight - nY1)
       endif
elseif nX0        == 0                    // It is in the right
       nX         := (nX1 + 1)
       nY         := (nDeskHeight - 1)
       nWidth     := (nDeskWidth  - nX1)
else                                      // It is in the left
       nX         := 0
       nY         := 0
       nWidth     := nX0
endif
if     cWhich == NIL
       RETURN {nX,nY, nWidth,nHeight}
elseif cWhich  $ 'Ss'
       RETURN {nWidth,nHeight}
elseif cWhich  $ 'Pp'
       RETURN {nX,nY}
endif
RETURN NIL

 ////////////
 //
FUNCTION ApiLoadDll_(cDll, cError)
 //      Loads a dll and returns its handle.
 //               <cDll>      -> Dll name. Its extension will be inserted
 //               [@<cError>] -> Error loading the dll
 //      Retorns the handle of the dll or 0 if it was not loaded
 //
 /////
STATIC aDllLoaded := {}                  // Loaded dlls: {{cDllName, nDllHandle}, ...}
LOCAL  nDllHandle

cDll := Lower(AllTrim(cDll))
if Right(cDll, 4) <> '.dll'
   cDll           += '.dll'
endif

nDllHandle    := AScan(aDllLoaded, {|x| x[01] == cDll})
if nDllHandle  > 0
   nDllHandle := aDllLoaded[nDllHandle, 02]
else
   nDllHandle    := DllLoad(cDll)
   if nDllHandle  > 0
      AAdd(aDllLoaded, {cDll, nDllHandle})
   else
      cError := DosErrorMessage(DosError())
   endif
endif
RETURN nDllHandle

